#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1800eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 1800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight18004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight18004xi = {
                1:'-1001x-1137y-971z',
                2:'-1012x-1487y-53z',
                3:'-1024x-932y-1149z',
                4:'-1066x-1090y-955z',
                5:'-1080x-884y-1135z',
                6:'-1089x-1432y-35z',
                7:'-1128x-1039y-940z',
                8:'-1134x-833y-1121z',
                9:'-114x-335y-1764z',
                10:'-1163x-1373y-17z',
                11:'-1185x-779y-1107z',
                12:'-1188x-985y-925z',
                13:'-120x-1205y-1331z',
                14:'-1233x-1310y0z',
                15:'-1234x-721y-1093z',
                16:'-1246x-927y-909z',
                17:'-1280x-660y-1078z',
                18:'-129x-1382y-1145z',
                19:'-1300x-865y-894z',
                20:'-1322x-597y-1064z',
                21:'-132x-1779y-233z',
                22:'-133x-604y-1690z',
                23:'-1351x-800y-878z',
                24:'-1362x-531y-1049z',
                25:'-138x-344y-1761z',
                26:'-1398x-462y-1035z',
                27:'-1399x-733y-862z',
                28:'-1430x-391y-1020z',
                29:'-1443x-662y-846z',
                30:'-1458x-318y-1005z',
                31:'-1483x-242y-990z',
                32:'-1484x-589y-830z',
                33:'-1503x-165y-975z',
                34:'-1520x-513y-814z',
                35:'-1553x-435y-798z',
                36:'-1581x-354y-782z',
                37:'-163x-353y-1757z',
                38:'-169x-612y-1684z',
                39:'-17x-264y-1780z',
                40:'-185x-1210y-1319z',
                41:'-190x-359y-1753z',
                42:'-203x-1384y-1131z',
                43:'-206x-619y-1677z',
                44:'-217x-364y-1749z',
                45:'-225x-1772y-215z',
                46:'-244x-622y-1670z',
                47:'-246x-366y-1744z',
                48:'-250x-1211y-1307z',
                49:'-275x-367y-1740z',
                50:'-277x-1383y-1117z',
                51:'-283x-624y-1664z',
                52:'-305x-365y-1735z',
                53:'-317x-1209y-1294z',
                54:'-318x-1760y-197z',
                55:'-323x-623y-1657z',
                56:'-336x-362y-1730z',
                57:'-33x-281y-1777z',
                58:'-352x-1377y-1103z',
                59:'-364x-620y-1650z',
                60:'-366x-355y-1725z',
                61:'-384x-1203y-1282z',
                62:'-398x-347y-1720z',
                63:'-39x-1781y-250z',
                64:'-3x-247y-1782z',
                65:'-405x-613y-1642z',
                66:'-410x-1743y-179z',
                67:'-427x-1367y-1089z',
                68:'-429x-336y-1715z',
                69:'-446x-605y-1635z',
                70:'-451x-1193y-1269z',
                71:'-460x-323y-1709z',
                72:'-487x-593y-1627z',
                73:'-491x-308y-1704z',
                74:'-501x-1721y-161z',
                75:'-502x-1353y-1074z',
                76:'-517x-1180y-1256z',
                77:'-51x-296y-1774z',
                78:'-521x-290y-1698z',
                79:'-529x-579y-1620z',
                80:'-551x-270y-1692z',
                81:'-56x-1196y-1343z',
                82:'-56x-1375y-1159z',
                83:'-570x-561y-1612z',
                84:'-576x-1335y-1060z',
                85:'-580x-247y-1685z',
                86:'-584x-1162y-1243z',
                87:'-591x-1693y-143z',
                88:'-607x-222y-1679z',
                89:'-610x-541y-1604z',
                90:'-634x-195y-1672z',
                91:'-650x-1141y-1230z',
                92:'-650x-1312y-1045z',
                93:'-650x-519y-1595z',
                94:'-660x-166y-1666z',
                95:'-680x-1661y-125z',
                96:'-684x-134y-1659z',
                97:'-690x-493y-1587z',
                98:'-69x-613y-1796z',
                99:'-707x-101y-1652z',
                100:'-70x-310y-1771z',
                101:'-716x-1115y-1217z',
                102:'-723x-1286y-1030z',
                103:'-727x-65y-1645z',
                104:'-728x-465y-1578z',
                105:'-765x-434y-1570z',
                106:'-766x-1625y-107z',
                107:'-780x-1086y-1204z',
                108:'-795x-1255y-1016z',
                109:'-801x-400y-1561z',
                110:'-835x-364y-1552z',
                111:'-844x-1053y-1190z',
                112:'-851x-1583y-89z',
                113:'-865x-1220y-1001z',
                114:'-867x-325y-1543z',
                115:'-898x-284y-1533z',
                116:'-905x-1016y-1177z',
                117:'-91x-323y-1768z',
                118:'-926x-240y-1524z',
                119:'-933x-1537y-71z',
                120:'-934x-1180y-986z',
                121:'-966x-976y-1163z',
                122:'-98x-593y-1696z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1800eight4xi" usage = "target function for charge1800eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1800eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1800EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1800EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1800EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1800EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1800EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight18004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1800EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1800EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1800EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight18004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight18004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1800EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1800EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1800EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1800eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  